Index: LMDZ6/trunk/libf/phylmd/inlandsis/inlandsis.F
===================================================================
--- LMDZ6/trunk/libf/phylmd/inlandsis/inlandsis.F	(revision 3897)
+++ LMDZ6/trunk/libf/phylmd/inlandsis/inlandsis.F	(revision 3900)
@@ -1066,17 +1347,16 @@
           endif
  
-
-! pour le moment, on choisit une valeur fixe
-          Z0_obs = 1.000e-3
- 
-cCA       Snow roughness lenght deduced from observations
-cCA       (parametrization if no Blowing Snow)
-cCA       ----------------------------------- C. Agosta 09-2016 -----
-cCA       Substract Z0enSV(ikl) because re-added later in Z0mnSV(ikl)
-          Z0m_Sn = Z0_obs - Z0enSV(ikl)
-cCA       -----------------------------------------------------------
- 
-          param = Z0_obs/1. ! param(s) | 1.(m/s)=TUNING
- 
+          Z0m_Sn=Z0_obs
+
+
+          ELSE
+
+          Z0m_Sn=0.500e-3  ! default=0.500e-3m (tuning of MAR) 
+
+          ENDIF
+ 
+
+
+!          param = Z0_obs/1. ! param(s) | 1.(m/s)=TUNING 
 c #SZ     Z0Sa_N =                   (us__SV(ikl) -0.2)*param   ! 0.0001=TUNING
 c #SZ.           * max(zero,sign(unun,TfSnow-eps9
@@ -1109,4 +1389,5 @@
 c #ZN     Z0enSV(ikl) =  max(Z0enSV(ikl), Z0m_nu)
  
+
 C +--Z0 Smooth Regime over Snow (Andreas etAl., 2004
 C +  ^^^^^^^^^^^^^^^^^^^^^^^^^^  ams.confex.com/ams/pdfpapers/68601.pdf)
@@ -1132,15 +1413,16 @@
 c #ZA     Z0m_Sn =           DDs_SV(ikl)* Z0m_90 / 45.
 c #ZA.         - DDs_SV(ikl)*DDs_SV(ikl)* Z0m_90 /(90.*90.)
- 
-C +--Z0  (Erosion)    over Snow (instantaneous or time average)
+
+
+
+
+C +--Z0  (Erosion)    over Snow (instantaneous)
 C +  ^^^^^^^^^^^^^^^^^^^^^^^^^^
           Z0e_SV(ikl) =  Z0enSV(ikl)
-          Z0e_SV(ikl) =  Z0emSV(ikl)
- 
-C +--Momentum  Roughness Length
-C +  ^^^^^^^^^^^^^^^^^^^^^^^^^^                              ! Contribution of
-          Z0mnSV(ikl) =  Z0mLnd                              ! land Form
-     .                + (Z0m_Sn                              ! Sastrugi   Form
-     .                +  Z0enSV(ikl))   *SnoMsk              ! Snow    Erosion
+ 
+C +--Momentum  Roughness Length (Etienne: changes wrt original SISVAT)
+C +  ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^                              
+          Z0mnSV(ikl) =  Z0m_nu *(1-SnoMsk)                     ! Ice z0
+     .                + (Z0m_Sn)*SnoMsk                         ! Snow Sastrugi Form and Snow Erosion
  
 
@@ -1154,21 +1436,7 @@
 c #GL.                     /(920.00                 -600.))) !
  
-C +--Mom. Roughness Length, Instantaneous OR Box Moving Average in Time
-C +  ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
+C +--Mom. Roughness Length, Instantaneous
+C +  ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
           Z0m_SV(ikl) =  Z0mnSV(ikl)                         ! Z0mnSV  instant.
-!          Z0m_SV(ikl) =  Z0mmSV(ikl)                         ! Z0mnSV  Average
- 
-C +--Corrected Threshold Friction Velocity before Erosion    ! Marticorena and
-C +  ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^    ! Bergametti 1995
-! not used anymore since Marticorena and Bergametti disabled !CK 18/07/2018
-cc #BS     Z0e_SV(ikl) =   min(Z0m_SV(ikl),Z0e_SV(ikl))       !
-cc #MB     f_eff=    log(0.35*(0.1        /Z0e_SV(ikl))**0.8) ! JGR 100
-cc #MB     f_eff=1.-(log(      Z0m_SV(ikl)/Z0e_SV(ikl)      ))! (20) p. 16420
-cc #MB.            /(max(      f_eff      ,epsi             ))! p.16426 2nd ?
-cc #MB     f_eff=    max(      f_eff      ,epsi              )! CONTROL
-cc #MB     f_eff=1.0   -(1.0 - f_eff)     /5.00               ! TUNING
-cc #MB     f_eff=    min(      f_eff      ,1.00              )!
-cc #MB    usthSV(ikl) =       usthSV(ikl)/f_eff              !
- 
  
  
@@ -1177,43 +1445,46 @@
  
           Z0hnSV(ikl) =     Z0mnSV(ikl)/  7.4
-c #SH     Z0hnSV(ikl) =     Z0mnSV(ikl)/100.0
-C +                         Z0h = Z0m  /100.0   over the Sahel
-C +                                            (Taylor & Clark, QJRMS 127,p864)
- 
-c #RN     rstar       =     Z0mnSV(ikl) * us__SV(ikl) / akmol
-c #RN     rstar       = max(epsi,min(rstar,thous))
-c #RN     alors       =          log(rstar)
-c #RN     rstar0      = 1.250e0 * max(zero,sign(unun,0.135e0 - rstar))
-c #RN.                +(1.      - max(zero,sign(unun,0.135e0 - rstar)))
-c #RN.                *(0.149e0 * max(zero,sign(unun,2.500e0 - rstar))
-c #RN.                + 0.317e0
-c #RN.                *(1.      - max(zero,sign(unun,2.500e0 - rstar))))
-c #RN     rstar1      = 0.      * max(zero,sign(unun,0.135e0 - rstar))
-c #RN.                +(1.      - max(zero,sign(unun,0.135e0 - rstar)))
-c #RN.                *(-0.55e0 * max(zero,sign(unun,2.500e0 - rstar))
-c #RN.                - 0.565
-c #RN.                *(1.      - max(zero,sign(unun,2.500e0 - rstar))))
-c #RN     rstar2      = 0.      * max(zero,sign(unun,0.135e0 - rstar))
-c #RN.                +(1.      - max(zero,sign(unun,0.135e0 - rstar)))
-c #RN.                *(0.      * max(zero,sign(unun,2.500e0 - rstar))
-c #RN.                - 0.183
-c #RN.                *(unun    - max(zero,sign(unun,2.500e0 - rstar))))
- 
-cXF    #RN does not work over bare ice
-cXF    MAR is then too warm and not enough melt
- 
-c #RN     if(ro__SV(ikl,isnoSV(ikl))>50
-c #RN.  .and.ro__SV(ikl,isnoSV(ikl))<roSdSV)then
- 
-c #RN     Z0hnSV(ikl) = max(zero
-c #RN.                , sign(unun,zzsnsv(ikl,isnoSV(ikl))-epsi))
-c #RN.                * exp(rstar0+rstar1*alors+rstar2*alors*alors)
-c #RN.                * 0.001e0 + Z0hnSV(ikl) * ( 1. - max(zero
-c #RN.                , sign(unun,zzsnsv(ikl,isnoSV(ikl))-epsi)))
- 
-c #RN     endif
+ 
+          IF (is_ok_z0h_rn) THEN
+
+          rstar       =     Z0mnSV(ikl) * us__SV(ikl) / akmol
+          rstar       = max(epsi,min(rstar,R_1000))
+          alors       =          log(rstar)
+          rstar0      = 1.250e0 * max(zero,sign(unun,0.135e0 - rstar))
+     .                +(1.      - max(zero,sign(unun,0.135e0 - rstar)))
+     .                *(0.149e0 * max(zero,sign(unun,2.500e0 - rstar))
+     .                + 0.317e0
+     .                *(1.      - max(zero,sign(unun,2.500e0 - rstar))))
+          rstar1      = 0.      * max(zero,sign(unun,0.135e0 - rstar))
+     .                +(1.      - max(zero,sign(unun,0.135e0 - rstar)))
+     .                *(-0.55e0 * max(zero,sign(unun,2.500e0 - rstar))
+     .                - 0.565
+     .                *(1.      - max(zero,sign(unun,2.500e0 - rstar))))
+          rstar2      = 0.      * max(zero,sign(unun,0.135e0 - rstar))
+     .                +(1.      - max(zero,sign(unun,0.135e0 - rstar)))
+     .                *(0.      * max(zero,sign(unun,2.500e0 - rstar))
+     .                - 0.183
+     .                *(unun    - max(zero,sign(unun,2.500e0 - rstar))))
+ 
+          
+
+!XF    #RN (is_ok_z0h_rn) does not work well over bare ice
+!XF    MAR is then too warm and not enough melt
+ 
+         if(ro__SV(ikl,isnoSV(ikl))>50
+     .  .and.ro__SV(ikl,isnoSV(ikl))<roSdSV)then
+ 
+             Z0hnSV(ikl) = max(zero
+     .                , sign(unun,zzsnsv(ikl,isnoSV(ikl))-epsi))
+     .                * exp(rstar0+rstar1*alors+rstar2*alors*alors)
+     .                * 0.001e0 + Z0hnSV(ikl) * ( 1. - max(zero
+     .                , sign(unun,zzsnsv(ikl,isnoSV(ikl))-epsi)))
+ 
+          endif
+
+
+          ENDIF
   
           Z0h_SV(ikl) =     Z0hnSV(ikl)
-!          Z0h_SV(ikl) =     Z0hmSV(ikl)
  
 
Index: LMDZ6/trunk/libf/phylmd/inlandsis/sisvat_bsn.F
===================================================================
--- LMDZ6/trunk/libf/phylmd/inlandsis/sisvat_bsn.F	(revision 3897)
+++ LMDZ6/trunk/libf/phylmd/inlandsis/sisvat_bsn.F	(revision 3900)
@@ -9,13 +9,7 @@
 C |                                                                        |
 C |   SISVAT_bsn computes the snow erosion mass according to both the      |
-C |   theoretical maximum erosion amount computed in SISVATesbl and the    |
+C |   theoretical maximum erosion amount computed in inlandsis and the     |
 C |   availability of snow (currently in the uppermost snow layer only)    |
 C |                                                                        |
-C |   Preprocessing  Option: SISVAT IO (not always a standard preprocess.) |
-C |   ^^^^^^^^^^^^^^^^^^^^^  ^^^^^^^^^                                     |
-C |   FILE                 |      CONTENT                                  |
-C |   ~~~~~~~~~~~~~~~~~~~~~+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ |
-C | # stdout               | #sb: OUTPUT of Snow Erosion                   |
-C |                        |      unit  6, SubRoutine  SISVAT_BSn **ONLY** |
 C +------------------------------------------------------------------------+
  
Index: LMDZ6/trunk/libf/phylmd/inlandsis/sisvat_qsn.F
===================================================================
--- LMDZ6/trunk/libf/phylmd/inlandsis/sisvat_qsn.F	(revision 3897)
+++ LMDZ6/trunk/libf/phylmd/inlandsis/sisvat_qsn.F	(revision 3900)
@@ -61,4 +61,6 @@
       use VARxSV
       use VARySV
+      use surface_data, only: is_ok_slush,opt_runoff_ac
+
 
       IMPLICIT NONE
@@ -235,5 +237,6 @@
  
       DO ikl=1,knonv
-       DO isn=min(nsno,isnoSV(ikl)+1),1,-1
+
+      DO isn=min(nsno,isnoSV(ikl)+1),1,-1
 ! EV          DO isn=nsno,1,-1
 C +--Energy, store Previous Content
@@ -243,7 +246,4 @@
      .                + ro__SV(ikl,isn) * Cn_dSV * dTSnow
      .                                           * dzsnSV(ikl,isn)
-
-          Tsave       = TsisSV(ikl,isn)
-
           TsisSV(ikl,isn) =                        TfSnow
  
@@ -312,13 +312,6 @@
           rdzNEW      = WaFrez + rdzsno
           ro__SV(ikl,isn) =      rdzNEW /max(epsi, dzsnSV(ikl,isn))
-
-! EV: condition on Enfrez
-!          if (EnFrez .eq. 0.) then
-          
-          TsisSV(ikl,isn) = Tsave
-!          else
           TsisSV(ikl,isn) =      TfSnow
      .                + EnFrez /(Cn_dSV *max(epsi, rdzNEW)        )
-!          end if
           EExcsv(ikl) =          EExcsv(ikl)     - EnFrez
           wer_SV(ikl) = WaFrez
@@ -499,9 +492,10 @@
           rusnew      = rusnSV(ikl) * SWf_SV(ikl)
  
-          if(isnoSV(ikl)<=1) rusnew = 0.
+          if(isnoSV(ikl)<=1 .OR. opt_runoff_ac) rusnew = 0.
           !if(ivgtSV(ikl)>=1) rusnew = 0.
  
 c #EU                        rusnew = 0.
-c #AC                        rusnew = 0.
+c #AC               rusnew = 0.
+
           RnofSV(ikl) = RnofSV(ikl)
      .                +(rusnSV(ikl) - rusnew     ) / dt__SV
@@ -545,37 +539,38 @@
         ENDDO
  
-C +--Slush Formation (CAUTION: ADD RunOff Possibility before Activation)
+C +--Slush Formation (Activated. CAUTION: ADD RunOff Possibility before Activation)
 C +  ---------------  ^^^^^^^  ^^^
  
- 
-c #SU DO  ikl=1,knonv
-c #SU  DO isn=1,isnoSV(ikl)
-c #SU     kSlush = min(1,max(0,isn+1-ispiSV(ikl)))        ! Slush Switch
+      IF (is_ok_slush) THEN 
+
+      DO  ikl=1,knonv
+       DO isn=1,isnoSV(ikl)
+          kSlush = min(1,max(0,isn+1-ispiSV(ikl)))        ! Slush Switch
  
 C +--Available Additional Pore   Volume [-]
 C +  ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
-c #SU     PorVol = 1. - ro__SV(ikl,isn)                    ! [--]
-c #SU.           *(1. - eta_SV(ikl,isn))/ ro_Ice           !
-c #SU.           -      eta_SV(ikl,isn)                    !
-c #SU.                 *ro__SV(ikl,isn) / ro_Wat           !
-c #SU     PorVol =  max(PorVol          , zero  )          !
-c #SU     zWater =      dzsnSV(ikl,isn) * PorVol * 1000.   ! [mm] OR [kg/m2]
-c #SU.           * (1. -SWS_SV(ikl)                        ! 0 <=> freezing
-c #SU.                *(1 -min(1,iabs(isn-isnoSV(ikl)))))  ! 1 <=> isn=isnoSV
-c #SU     zSlush =  min(rusnSV(ikl)     , zWater)          ! [mm] OR [kg/m2]
-c #SU     ro_new      =(dzsnSV(ikl,isn) * ro__SV(ikl,isn)  !
-c #SU.                 +zSlush                           ) !
-c #SU.            / max(dzsnSV(ikl,isn) , epsi           ) !
-c #SU     if(ro_new<ro_Ice+20) then ! MAX 940kg/m3         !
-c #SU      rusnSV(ikl)  = rusnSV(ikl)          - zSlush    ! [mm] OR [kg/m2]
-c #SU      RuofSV(ikl,4)= max(0.,RuofSV(ikl,4) - zSlush/dt__SV)
-c #SU      eta_SV(ikl,isn) =(ro_new - ro__SV(ikl,isn)      !
-c #SU.                     *(1.     - eta_SV(ikl,isn)))    !
-c #SU.                / max (ro_new , epsi            )    !
-c #SU      ro__SV(ikl,isn) =      ro_new                   !
-c #SU     endif
-c #SU   END DO
-c #SU END DO
- 
+          PorVol = 1. - ro__SV(ikl,isn)                    ! [--]
+     .           *(1. - eta_SV(ikl,isn))/ ro_Ice           !
+     .           -      eta_SV(ikl,isn)                    !
+     .                 *ro__SV(ikl,isn) / ro_Wat           !
+          PorVol =  max(PorVol          , zero  )          !
+          zWater =      dzsnSV(ikl,isn) * PorVol * 1000.   ! [mm] OR [kg/m2]
+     .           * (1. -SWS_SV(ikl)                        ! 0 <=> freezing
+     .                *(1 -min(1,iabs(isn-isnoSV(ikl)))))  ! 1 <=> isn=isnoSV
+          zSlush =  min(rusnSV(ikl)     , zWater)          ! [mm] OR [kg/m2]
+          ro_new      =(dzsnSV(ikl,isn) * ro__SV(ikl,isn)  !
+     .                 +zSlush                           ) !
+     .            / max(dzsnSV(ikl,isn) , epsi           ) !
+          if(ro_new<ro_Ice+20) then ! MAX 940kg/m3         !
+           rusnSV(ikl)  = rusnSV(ikl)          - zSlush    ! [mm] OR [kg/m2]
+           RuofSV(ikl,4)= max(0.,RuofSV(ikl,4) - zSlush/dt__SV)
+           eta_SV(ikl,isn) =(ro_new - ro__SV(ikl,isn)      !
+     .                     *(1.     - eta_SV(ikl,isn)))    !
+     .                / max (ro_new , epsi            )    !
+           ro__SV(ikl,isn) =      ro_new                   !
+          endif
+        END DO
+      END DO
+      END IF
  
 C +--Impact of the Sublimation/Deposition on the Surface Mass Balance
